/* ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^ */
/*      ###           Implementacia interpretu jazyka IFJ09          ###      */  
/* ########################################################################## */
/*  Akademicky rok: 2009/2010 ## Predmet: IFJ ## Datum odovzdania : 13.12 09  */
/* |------------------------------------------------------------------------| */
/* |        Team              |   Login   |       Nazov a popis modulu      | */ 
/* |------------------------------------------------------------------------| */
/* | Martin Haviar - veduci   | xhavia01  |                                 | */
/* | Jozef  Henzl             | xhenzl04  |                                 | */
/* | Martin Herich            | xheric00  |                                 | */
/* | Maros  Barjak            | xbarja00  |                                 | */
/* \------------------------------------------------------------------------/ */
                                                                 
/*
 *	hashovacia tabulka ako tabulka symbolov 
 */

//#define NDEBUG  // vypne assert
#ifndef _HASH_H_
#define _HASH_H_

#ifdef  __cplusplus
extern "C" {
#endif

#include "str.h"

#define ID_MAX_LENGTH 31

#define T_INTEGER 1
#define T_DOUBLE 2
#define T_STRING 3

#define HT_NOT_FOUND 0
#define HT_INSERTED 0
#define HT_FOUND 1
#define HT_ERROR -1

// hodnota polozky
typedef union item_value
{
	int num_int;
	double num_double;
//	char *str;
	string_t _string;
} t_item_value;

// struktura polozky
typedef struct item htable_item;
struct item
{
    string_t name;	// neobmedzena dlzka nazvu identifikatoru
	int type;		
	int tmp;		// 0==normalna premenna, ine==docasna nemenna konstanta
    t_item_value data;	
    htable_item *next;
};

// struktura hash table
typedef struct hash_table
{
    int htable_size;
    htable_item **p;
} t_htable, tSymbolTable;


t_htable* htable_init(int );
void htable_clear(t_htable* );
void htable_free(t_htable* );
unsigned int hash_function(const char *, unsigned );
void _htable_write(t_htable *);
void htable_dispose(t_htable* );
int htable_lookup(t_htable *, htable_item **, char *, int);

#if DEBUG_ON
#define htable_write(table) _htable_write(table);
#else
#define htable_write(table) {}
#endif

#ifdef __cplusplus
}
#endif

#endif /* _HASH_H_ */
