#ifndef _INST_LST_H_
#define _INST_LST_H_

#ifdef  __cplusplus
extern "C" {
#endif

/* system includes */
/* local includes */
#include "hash.h"


typedef unsigned int il_addr_t;

typedef struct _inst {
	enum {

		INST_READ,
		INST_WRITE,
		INST_ADD,
		INST_SUB,
		INST_MUL,
		INST_DIV,
		INST_MOV,

		INST_CMP_LESS,
		INST_CMP_GREAT,
		INST_CMP_LESSEQ,
		INST_CMP_GREATEQ,
		INST_CMP_EQUAL,
		INST_CMP_NOTEQUAL,

		INST_FIND,
		INST_SORT, //---
		INST_CLR,

		INST_LABEL,
		INST_JMP,
		INST_JZ

	} type;
	htable_item *i1;
	htable_item *i2;
	htable_item *i3;
} instruction_t;

/**
* seznam instrukci je implementovan jako pole promenne delky. vyhneme se tak ne moc peknym
*	konstrukcim s void* a usnadnime si vyhledavani prvku podle adresy
*/
typedef struct {
	instruction_t **instr;
	int _segs;				/**< pocet segmentu pro instrukce */
	il_addr_t _a_size;			/**< posledni zabrana adresa */
	il_addr_t _a_max;			/**< addr of last instruction */
	il_addr_t _a_cur;			/**< current instruction (aka program counter) */
} ilist_t;

/**
* inicializace seznamu instrukci. funkce vrati adresu pameti nove alokovane struktury,
*	nebo NULL v pripade chyby. alokovanou pamet je potreba uvolnit funkci ilist_free()
*/
ilist_t *ilist_new();

/**
* vytvori novou instrukci na konci seznamu
* @return adresa nove vytvorene instrukce, NULL v pripade chyby
*/
instruction_t *ilist_addi_end(ilist_t *ilist);


/**
* skok na urcenou adresu.
* @return 0 pri uspechu, jinak -1
*/ 
int ilist_goto(ilist_t *ilist, il_addr_t addr);


/**
* uvolneni pameti alokovane seznamem instrukci
*/
void ilist_free(ilist_t *ilist);

/**
* get next instruction from the list and increment pc
*/
instruction_t *ilist_getnext_inst(ilist_t *ilist);

il_addr_t ilist_last_addr(ilist_t *ilist);
#ifdef __cplusplus
}
#endif

#endif /* _INST_LST_H_ */

