/* ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^ */
/*      ###           Implementacia interpretu jazyka IFJ09          ###      */  
/* ########################################################################## */
/*  Akademicky rok: 2009/2010 ## Predmet: IFJ ## Datum odovzdania : 13.12 09  */
/* |------------------------------------------------------------------------| */
/* |        Team              |   Login   |       Nazov a popis modulu      | */ 
/* |------------------------------------------------------------------------| */
/* | Martin Haviar - veduci   | xhavia01  |                                 | */
/* | Jozef  Henzl             | xhenzl04  |                                 | */
/* | Martin Herich            | xheric00  |                                 | */
/* | Maros  Barjak            | xbarja00  |                                 | */
/* \------------------------------------------------------------------------/ */
                                                                 
/*
 *		Syntakticka analyza rekurzivnym zostupom
 */

#ifndef _PARSER_H_
#define _PARSER_H_

#ifdef  __cplusplus
extern "C" {
#endif


/* local includes */
#include "hash.h"
#include "inst_lst.h"

#define SYNTAX_OK     0

#define LEX_ERROR    1
#define SYNTAX_ERROR 2
#define SEM_ERROR    3
#define INT_ERROR    4 //  - chyba interpretu
#define RUN_ERROR    5 //- chyba alokacie | pri otvoreni suboru

// konstanty na PA tabulku
#define PA_PLUS         0  // +
#define PA_MINUS        1  // -
#define PA_MULT         2  // *
#define PA_DIV          3  // div
#define PA_LBRACKET     4  // (
#define PA_RBRACKET     5  // )
#define PA_ID           6  // i
#define PA_EQ           7  // =
#define PA_NEQ          8  // <>
#define PA_LESS         9  // <
#define PA_LESSEQ      10  // <=
#define PA_GRE         11  // >
#define PA_GREEQ       12  // >=
#define PA_DOLLAR      13  // $
#define PA_NONTERMINAL 14  // E

//void generateVariable(string *);
//void generateInstruction(int , void *, void *, void *);
//int prog();

int _stat_body();
int _declr(); 
int parse(tSymbolTable *ST, ilist_t *instrList);
int _declr_list();
int _stat_list();
int _type(int *type);
void *generate_not_instr(htable_item *expr_result);
void RepeatLastToken();
int getToken(string_t *_attr);

#ifdef __cplusplus
}
#endif

#endif /* _PARSER_H_ */

