/* ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^ */
/*      ###           Implementacia interpretu jazyka IFJ09          ###      */  
/* ########################################################################## */
/*  Akademicky rok: 2009/2010 ## Predmet: IFJ ## Datum odovzdania : 13.12 09  */
/* |------------------------------------------------------------------------| */
/* |        Team              |   Login   |       Nazov a popis modulu      | */ 
/* |------------------------------------------------------------------------| */
/* | Martin Haviar - veduci   | xhavia01  |  Modul obsahujuci funkcie       | */
/* | Jozef  Henzl             | xhenzl04  |  zasobniku                      | */
/* | Martin Herich            | xheric00  |                                 | */
/* | Maros  Barjak            | xbarja00  |                                 | */
/* \------------------------------------------------------------------------/ */

#include "stack.h"

/**
* inicializuje zasobnik
* @param zasobnik ukazatel na zasobnik
*/
void stackInit(stack_t *zasobnik)
{
  zasobnik->top = NULL;
}

/**
* zrusi zasobnik a uvolni vsetky prvky
* @param zasobnik ukazatel na zasobnik
*/
void stackDispose(stack_t *zasobnik)
{
  htable_item *pom_ht_elem;
  while(!stackEmpty(zasobnik))
  {
    stackTopPop(zasobnik, &pom_ht_elem);
  }
}

/**
* vrati, ci je zasobnik prazdny
* @param zasobnik ukazatel na zasobnik
*/
int stackEmpty(stack_t *zasobnik)
{
  if(zasobnik->top == NULL)
    return TRUE;
  else
    return FALSE;
}

/**
* vybere a vrati prvy prvok na zasobniku
* @param zasobnik ukazatel na zasobnik
* @param ptr ukazatel na prvok v hash tabulke
*/
int stackTopPop(stack_t *zasobnik, htable_item **htiptr)
{
  stack_elem_ptr_t pom_uk_elem;
  int pom_symbol;

  if(stackEmpty(zasobnik))                  // zasobnik nesmie byt prazdny
    return -1;
  else  
  {
    
    pom_symbol = zasobnik->top->token;      // symbol si ulozime do pomocnej
    (*htiptr) = zasobnik->top->htiptr;      // do htiptr ulozime adresu na htable_item
    pom_uk_elem = zasobnik->top;            // uk na vrchol si ulozime do pomocnej
    zasobnik->top = zasobnik->top->next;    // popneme vrcholovy prvok
    free(pom_uk_elem);                      // uvolnime co zostalo
    zasobnik->act = zasobnik->top;          // nastavime aktivitu na vrchol
    
    return pom_symbol;
  }	
}

/**
* vrati aktivny prvok a posunie aktivitu na nasledujuci prvok
* @param zasobnik ukazatel na zasobnik
*/
int stackGetActSucc(stack_t *zasobnik)
{
  int pom_symbol;
  
  if(zasobnik->act != NULL)                 // pokial sme sa este nedostali na koniec
  {
    pom_symbol = zasobnik->act->token;      // vrat aktualny token
    zasobnik->act = zasobnik->act->next;    // posun na dalsi prvok
  }
  else 
    pom_symbol = -1;  
  
  return pom_symbol;
}
 
/**
* da na vrchol zasobniku token/symbol
* @param zasobnik ukazatel na zasobnik
* @param symbol token/symbol, ktory ulozime
* @param ptr ukazatel na prvok v hash tabulke
*/
void stackPush(stack_t *zasobnik, int symbol, htable_item *htiptr)
{
  stack_elem_ptr_t pom_uk_elem;
  
  pom_uk_elem = malloc(sizeof(struct stack_element));
  if(pom_uk_elem == NULL)
  {
    printf("Chyba alokacie\n");         // alebo ina chybova hlaska
    return;
  }
  pom_uk_elem->token = symbol;          // naplnenie prvku
  pom_uk_elem->htiptr = htiptr;
  pom_uk_elem->next = zasobnik->top;    
  zasobnik->top = pom_uk_elem;          // nastavime vrchol ...
  zasobnik->act = zasobnik->top;        // ... a aktivitu
}

